package com.izouma.dingdong.web.user;

import com.izouma.dingdong.web.BaseController;
import com.izouma.dingdong.domain.user.MyCollection;
import com.izouma.dingdong.service.user.MyCollectionService;
import com.izouma.dingdong.dto.PageQuery;
import com.izouma.dingdong.exception.BusinessException;
import com.izouma.dingdong.repo.user.MyCollectionRepo;
import com.izouma.dingdong.utils.ObjUtils;
import com.izouma.dingdong.utils.excel.ExcelUtils;

import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/myCollection")
@AllArgsConstructor
public class MyCollectionController extends BaseController {
    private MyCollectionService myCollectionService;
    private MyCollectionRepo myCollectionRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public MyCollection save(@RequestBody MyCollection record) {
        if (record.getId() != null) {
            MyCollection orig = myCollectionRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return myCollectionRepo.save(orig);
        }
        return myCollectionRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @GetMapping("/all")
    public Page<MyCollection> all(PageQuery pageQuery) {
        return myCollectionRepo.findAll(toSpecification(pageQuery,MyCollection.class), toPageRequest(pageQuery));
    }

    @GetMapping("/get/{id}")
    public MyCollection get(@PathVariable Long id) {
        return myCollectionRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        myCollectionRepo.deleteById(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<MyCollection> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

